      subroutine checkpl(ipl0,ipl,ipk)
c----------------------------------------------------------------------c
c Checks if particles ipl0+1, ipl0+2, ..., ipl have been already 
c generated. If yes, labels of the corresponding particles are returned
c in ipk.
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 15/16 June, 2006; modified 14 October, 2006
c 10 Jan. 2016:
c Lower limit in do j loop shifted to nexpl+1
c----------------------------------------------------------------------c

      use intpart

      implicit none

      integer :: ipl0,ipl,ipl1,ipk(mxvpl),i,j,icheck,ip,blad,ich

      ipk=0
      ipl1=ipl
      ip=0
      ich=0

      do i=ipl0+1,ipl1
       ip=ip+1
       ipk(ip)=i
       icheck=0
c       do j=1,ipl0
       do j=nexpl+1,ipl0  ! 10 Jan. 2016
        if (pl(i)%k(1) == pl(j)%k(1) .and. 
     &      pl(i)%k(2) == pl(j)%k(2) .and. 
     &      pl(i)%k(3) == pl(j)%k(3) .and. 
     &      pl(i)%k(4) == pl(j)%k(4)) then
c Particle i has been already generated as particle j
         icheck=1
         ipk(ip)=j
         pl(i)%mx=0     ! 14 April 2014
         exit
        end if
       end do
       if (icheck == 1) ich=ich+1
      end do

      if (icheck == 1) then
       if(ich == ipl-ipl0) then
        ipl=ipl0
        do i=ipl0+1,ipl0+ich
         deallocate (pl(i)%ip,stat=blad)
        end do
       else
        write(*,*)'checpl.f: Something is wrong',ich,ipl-ipl0,ipl0,ipl
       end if
      end if

      end subroutine checkpl
